% Bi-modal flutter 
% av Henrik Skyvulstad og Trine Hollerud Odden


 
clc
clear all  
close all

%% 
%skal ta inn nye formfunksjoner fra abaqus, kun 1 retning, husk at torsjon
%alltid skal ha strst frekvens!!!
VALGT=[6 13];             %M velge 2!!!!
Nodes=186;                
L=3700;                   %Lengde brua i meter
B=18.3;                   %Bredde brua

%% Importer abaqus data
[Eigenvectors,Eigenvalues]=read_ABAQUS_dat('H.dat',Nodes);
omegaomega=(Eigenvalues(VALGT,3));

% Definerer moden.
Koordinater=Eigenvectors(:,2:4);
[~, b]=sort(Koordinater(:,1));
Koordinater=Koordinater(b,:);

phiphi=zeros(3,size(Eigenvectors,1),length(VALGT));
teller=1;
for n=1:length(omegaomega)
    phiphi(2,:,teller)=Eigenvectors(b,6,VALGT(n))';
    phiphi(1,:,teller)=Eigenvectors(b,7,VALGT(n))';
    phiphi(3,:,teller)=Eigenvectors(b,8,VALGT(n))';
    Skalering=max([phiphi(1,:,teller) phiphi(2,:,teller) B/2*phiphi(3,:,teller) ]);
    figure
    subplot(3,1,1)
    plot(Koordinater(:,1),phiphi(1,:,teller))
    ylim([-Skalering Skalering])
    title(['Mode ' num2str(VALGT(n)) ' \omega=' num2str(omegaomega(teller,1)) ' (rad/s)'])
    grid on
    subplot(3,1,2)
    plot(Koordinater(:,1),phiphi(2,:,teller))
    ylim([-Skalering Skalering])
    grid on
    subplot(3,1,3)
    plot(Koordinater(:,1),phiphi(3,:,teller))
    ylim([-2/B*Skalering 2/B*Skalering])
    grid on
    teller=teller+1;
end

%% Definer stille luft egenskapene
omegaomega=diag(Eigenvalues(VALGT,3));
M=diag(Eigenvalues(VALGT,5));
zetazeta=0.005.*diag(ones(length(VALGT),1));
K=omegaomega.^2*M;
C=2.*zetazeta.*M.*omegaomega;
omega=diag(omegaomega);

%Konstanter

V=10:5:150;

syms omegaw

ksiz=zetazeta(1,1);           %demping  z-retn
ksit=zetazeta(2,2);           %demping  t-retn
dx=L/(Nodes-1);               %itterasjonslengde
Lexp=3700;                    %eksponert lengde i meter
dxexp=L/(Nodes-1);            %eksponert itterasjonslende 
x=0:dx:L;                     %Lengdevektor hele brua
xexp=0:dxexp:Lexp;            %Lengdevektor eksponert
phi1=phiphi(2,:,1);           %formfuntion for vertikal
phi2=phiphi(3,:,2);           %formfuntion for torsjon
omegaz=omegaomega(1,1);                 
omegat=omegaomega(2,2);                 %husk at alltid torsjon m ha strt frekvens!!!
rho=1.25;                               %tetthet luft
me=M(1,1)/(sum(phi1.^2)*dx);            %fordelt masse vertikal
le=M(2,2)/(sum(phi2.^2)*dx);            %fordelt masse torsjon


for a=1:1:length(x)
dx1(1,a)=dx;
dxexp1(1,a)=dxexp;
end


%integrerte formfunksjoner
phiphi1=phi1.^2*dx1';
phiphi2=phi2.^2*dx1';
phiphi12=phi1.*phi2*dx1';
phiphiexp12=phi1.*phi2*dxexp1';
phiphiexp1=phi1.^2*dxexp1';
phiphiexp2=phi2.^2*dxexp1';
phiphiexp21=phi2.*phi1*dxexp1';

Cz=(phiphi12/phiphi1);
Ct=(phiphi12/phiphi2);


Yw=omegat/omegaz;
Ym=me/(rho*B^2);
Yl=le/(rho*B^4);
ohm=omegaw/omegaz;

for e=1:length(V)
vred(1,e)=V(1,e)/(omegaw*B);
end

%Aerodynamiske deriverte
P1=-0.2548*vred;
P2=0;
P3=0;
P4=0;
P5=-0.25*vred;
P6=0;
H1=0.1184*vred.^2-3.1629*vred;
H2=-0.3376*vred.^2+0.817*vred;
H3=2.3738*vred.^2-0.1944*vred;
H4=-0.1724*vred.^2-0.1315*vred;
H5=0.5*vred;
H6=0;
A1=-0.0778*vred.^2-0.5406*vred;
A2=-0.1375*vred.^2-0.0092*vred;
A3=0.8789*vred.^2-0.2887*vred;
A4=0.0595*vred.^2-0.3636*vred;
A5=-0.0200*vred;
A6=0;

%Egenverdilsningen

for n=1:1:length(V)

R1(1,n)=0;

R2(1,n)=-Yw^2-4*ksit*ksiz*Yw-1-A3(1,n)/(2*Yl)-Yw^2*H4(1,n)/(2*Ym);

R3(1,n)=ksit*Yw*H1(1,n)/Ym+ksiz*A2(1,n)/Yl;

R4(1,n)=1+H4(1,n)/(2*Ym)+A3(1,n)/(2*Yl)+(Ct*Cz*A1(1,n)*H2(1,n)-A2(1,n)*H1(1,n)+H4(1,n)*A3(1,n)-Ct*Cz*A4(1,n)*H3(1,n))/(4*Ym*Yl);

I1(1,n)=-Yw^2*H1(1,n)/(2*Ym)-A2(1,n)/(2*Yl);

I2(1,n)=-2*ksit*Yw-2*ksiz-ksit*Yw*H4(1,n)/Ym-ksiz*A3(1,n)/Yl;

I3(1,n)=H1(1,n)/(2*Ym)+A2(1,n)/(2*Yl)+(H4(1,n)*A2(1,n)+H1(1,n)*A3(1,n)-Cz*Ct*H3(1,n)*A1(1,n)-Cz*Ct*H2(1,n)*A4(1,n))/(4*Ym*Yl);

end

for m=1:1:length(V)

Eq1(1,m)=R4(1,m)*ohm^4+R3(1,m)*ohm^3+R2(1,m)*ohm^2+R1(1,m)*ohm+Yw^2;

Eq2(1,m)=I3(1,m)*ohm^3+I2(1,m)*ohm^2+I1(1,m)*ohm+2*ksiz*Yw^2+2*ksit*Yw;

end

for f=1:1:length(V)
    
Realrotter(:,f)=solve(Eq1(1,f),omegaw,'Real', true);

Imaginarrotter(:,f)=solve(Eq2(1,f),omegaw,'Real', true);

end

digits(64)

Realrotter1=Realrotter(1,:);
Realrotter2=Realrotter(2,:);
Realrotter3=Realrotter(3,:);
Realrotter4=Realrotter(4,:);

Imaginarrotter1=Imaginarrotter(1,:);
Imaginarrotter2=Imaginarrotter(2,:);
Imaginarrotter3=Imaginarrotter(3,:);

digits(32)

figure 
hold on
plot(V,Realrotter1,V,Imaginarrotter1,'r')

plot(V,Realrotter2,V,Imaginarrotter2,'r')

plot(V,Realrotter3,V,Imaginarrotter3,'r')

plot(V,Realrotter4)


