% Making a suspensionbridge, slottet box girder
clc
clear all
close all
%%
% Input parameters

L=3700;             %Length of main-span
dx=20;              %Spacing between hangers
N=L/dx + 1;         %Number of nodes along the bridge
Ht=380;             %height towers
Hc=L/10;            %sag cable
Hg=0.9*(Ht-Hc);     %sag girder
Hv=-60;             %Hight from orgin to water

j=4;                %Nodes pr 20m girder
k=4;                %Nodes pr 20m cable in main-span
l=6;                %Nodes cables side-span

x0=0;               %coordinates for det orgin of the bridge
y0=0;
z0=0;

z1=15-2.08-0.75;    % Distance from center bridge to girder
z2=15;              % Distance from center bridge to center right girder
z3=z2+3.4;          % Distance from center bridge to cable 


%%
% The function input for the girder nodes
x1=L/2;
y1=y0+Hg;
x2=L;
y2=y0;

p=[x0^2 x0 1; x1^2 x1 1; x2^2 x2 1]^(-1)*[y0;y1;y2];

% The function input for the cable nodes

x3=x0;
y3=y0+Ht;
x4=L/2;
y4=y3-Hc;
x5=L;
y5=y3;

q=[x3^2 x3 1; x4^2 x4 1; x5^2 x5 1]^(-1)*[y3;y4;y5];

%Coordinates, fixing the cable ends
xf1=x0-Ht;
dxc=abs(xf1-x0)/l;
dydx=abs(Ht-(q(1)*dx^2+q(2)*dx+q(3)))/dx;
yf1=y0+Ht+xf1*dydx;


xf2=x2+Ht;
yf2=y0+Ht+xf1*dydx;


%%

fw = fopen('Brusymf30.inp','wt');      %The new file to be written
fprintf(fw,['*Heading' '\n']);
fprintf(fw,['*Part, name=Part-1' '\n']);
fprintf(fw,['*NODE' '\n']);

for n=2:N-1 %Node mellom massels (hyre) og midtbjelke mellom brubaner
    f1=p(1)*(x0+(n-1)*dx)^2+p(2)*(x0+(n-1)*dx)+p(3);
    fprintf(fw,[num2str(n) ',\t' num2str(x0+(n-1)*dx) ',\t' num2str(f1) ',\t' num2str(z1) ',\t' '\n']);
end
for n=1:j*N-(j-1)  %Node senter brubane 1
    f1=p(1)*(x0+(n-1)*dx/j)^2+p(2)*(x0+(n-1)*dx/j)+p(3);
    fprintf(fw,[num2str(N+n) ',\t' num2str(x0+(n-1)*dx/j) ',\t' num2str(f1) ',\t' num2str(z2) ',\t' '\n']);
end
for n=2:N-1  %Node mellom massels og hengestang 1
    f1=p(1)*(x0+(n-1)*dx)^2+p(2)*(x0+(n-1)*dx)+p(3);
    fprintf(fw,[num2str((1+j)*N+n) ',\t' num2str(x0+(n-1)*dx) ',\t' num2str(f1) ',\t' num2str(z3) ',\t' '\n']);
end
for n=2:N-1  %Node mellom massels (venstre) og midtbjelke mellom brubaner
    f1=p(1)*(x0+(n-1)*dx)^2+p(2)*(x0+(n-1)*dx)+p(3);
    fprintf(fw,[num2str((2+j)*N+n) ',\t' num2str(x0+(n-1)*dx) ',\t' num2str(f1) ',\t' num2str(-z1) ',\t' '\n']);
end
for n=1:j*N-(j-1)  %Node senter brubane 2
    f1=p(1)*(x0+(n-1)*dx/j)^2+p(2)*(x0+(n-1)*dx/j)+p(3);
    fprintf(fw,[num2str((3+j)*N+n) ',\t' num2str(x0+(n-1)*dx/j) ',\t' num2str(f1) ',\t' num2str(-z2) ',\t' '\n']);
end
for n=2:N-1 %Node mellom massels og hengestang 2
    f1=p(1)*(x0+(n-1)*dx)^2+p(2)*(x0+(n-1)*dx)+p(3);
    fprintf(fw,[num2str((3+2*j)*N+n) ',\t' num2str(x0+(n-1)*dx) ',\t' num2str(f1) ',\t' num2str(-z3) ',\t' '\n']);
end
for n=1:k*N-(k-1) %Node mellom hengestang 1 og kabel 1
    f2=q(1)*(x0+(n-1)*dx/k)^2+q(2)*(x0+(n-1)*dx/k)+q(3);
    fprintf(fw,[num2str((4+2*j)*N+n) ',\t' num2str(x0+(n-1)*dx/k) ',\t' num2str(f2) ',\t' num2str(z3) ',\t' '\n']);
end
for n=1:k*N-(k-1) %Node mellom hengestang 2 og kabel 2
    f2=q(1)*(x0+(n-1)*dx/k)^2+q(2)*(x0+(n-1)*dx/k)+q(3);
    fprintf(fw,[num2str((4+2*j+k)*N+n) ',\t' num2str(x0+(n-1)*dx/k) ',\t' num2str(f2) ',\t' num2str(-z3) ',\t' '\n']);
end
for n=2:N-1 %Node midt 
    f1=p(1)*(x0+(n-1)*dx)^2+p(2)*(x0+(n-1)*dx)+p(3);
    fprintf(fw,[num2str((5+2*j+2*k)*N+n) ',\t' num2str(x0+(n-1)*dx) ',\t' num2str(f1) ',\t' num2str(z0) ',\t' '\n']);
end

for n=1:l
fprintf(fw,[num2str((6+2*j+2*k)*N+n) ',\t' num2str(xf1-(1-n)*dxc) ',\t' num2str(y0+Ht+(xf1-(1-n)*dxc)*dydx) ',\t' num2str(z3) ',\t' '\n']);
end
for n=1:l
fprintf(fw,[num2str((6+2*j+2*k)*N+l+n) ',\t' num2str(xf1-(1-n)*dxc) ',\t' num2str(y0+Ht+(xf1-(1-n)*dxc)*dydx) ',\t' num2str(-z3) ',\t' '\n']);
end
for n=1:l
fprintf(fw,[num2str((6+2*j+2*k)*N+2*l+n) ',\t' num2str(xf2+(1-n)*dxc) ',\t' num2str(y0+Ht-((xf2-x2)+(1-n)*dxc)*dydx) ',\t' num2str(z3) ',\t' '\n']);
end
for n=1:l
fprintf(fw,[num2str((6+2*j+2*k)*N+3*l+n) ',\t' num2str(xf2+(1-n)*dxc) ',\t' num2str(y0+Ht-((xf2-x2)+(1-n)*dxc)*dydx) ',\t' num2str(-z3) ',\t' '\n']);
end

fprintf(fw,['*Element, type=B33' '\n']);

for n=1:N-2 %Element midtbjelke
    fprintf(fw,[num2str(n) ',\t' num2str(n+1) ',\t' num2str((5+2*j+2*k)*N+n+1) ',\t' '\n']);
end
for n=1:N-2 %Element midtbjelke
    fprintf(fw,[num2str(N+n) ',\t' num2str((5+2*j+2*k)*N+n+1) ',\t' num2str((2+j)*N+n+1) ',\t' '\n']);
end
for n=1:N-2 %Element massels hyre
    fprintf(fw,[num2str(2*N+n) ',\t' num2str(N+n*j+1) ',\t' num2str(n+1) ',\t' '\n']);
end
for n=1:N-2 %Element massels hyre
    fprintf(fw,[num2str(3*N+n) ',\t' num2str(N+n*j+1) ',\t' num2str((1+j)*N+n+1) ',\t' '\n']);
end
for n=1:N-2 %Element massels venstre
    fprintf(fw,[num2str(4*N+n) ',\t' num2str((2+j)*N+n+1) ',\t' num2str((3+j)*N+n*j+1) ',\t' '\n']);
end
for n=1:N-2 %Element massels venstre
    fprintf(fw,[num2str(5*N+n) ',\t' num2str((3+j)*N+n*j+1) ',\t' num2str((3+2*j)*N+n+1) ',\t' '\n']);
end
for n=1:j*N-j %Element brubane 1
    fprintf(fw,[num2str(6*N+n) ',\t' num2str(N+n) ',\t' num2str(N+n+1) ',\t' '\n']);
end
for n=1:j*N-j %Element brubane 2
    fprintf(fw,[num2str((6+j)*N+n) ',\t' num2str((3+j)*N+n) ',\t' num2str((3+j)*N+n+1) ',\t' '\n']);
end
for n=1:k*N-k %Element kabel hyre
    fprintf(fw,[num2str((6+2*j)*N+n) ',\t' num2str((4+2*j)*N+n) ',\t' num2str((4+2*j)*N+n+1) ',\t' '\n']);
end
for n=1:k*N-k %Element kabel venstre
    fprintf(fw,[num2str((6+2*j+k)*N+n) ',\t' num2str((4+2*j+k)*N+n) ',\t' num2str((4+2*j+k)*N+n+1) ',\t' '\n']);
end
for n=1:N-2 %Hengestenger hyre
    fprintf(fw,[num2str((6+2*j+2*k)*N+n) ',\t' num2str((4+2*j)*N+n*k+1) ',\t' num2str((1+j)*N+n+1) ',\t' '\n']);
end
for n=1:N-2 %Hengestenger venstre
    fprintf(fw,[num2str((7+2*j+2*k)*N+n) ',\t' num2str((4+2*j+k)*N+n*k+1) ',\t' num2str((3+2*j)*N+n+1) ',\t' '\n']);
end

%Elementer sidekabel
if l > 1
for n=1:l-1
fprintf(fw,[num2str((8+2*j+2*k)*N+n) ',\t' num2str((6+2*j+2*k)*N+n) ',\t' num2str((6+2*j+2*k)*N+n+1) ',\t' '\n']);
end
for n=1:l-1
fprintf(fw,[num2str((8+2*j+2*k)*N+l+n) ',\t' num2str((6+2*j+2*k)*N+n+l) ',\t' num2str((6+2*j+2*k)*N+n+1+l) ',\t' '\n']);
end
for n=1:l-1
fprintf(fw,[num2str((8+2*j+2*k)*N+2*l+n) ',\t' num2str((6+2*j+2*k)*N+n+2*l) ',\t' num2str((6+2*j+2*k)*N+n+1+2*l) ',\t' '\n']);
end
for n=1:l-1
fprintf(fw,[num2str((8+2*j+2*k)*N+3*l+n) ',\t' num2str((6+2*j+2*k)*N+n+3*l) ',\t' num2str((6+2*j+2*k)*N+n+1+3*l) ',\t' '\n']);
end
end

fprintf(fw,[num2str((8+2*j+2*k)*N+4*l+1) ',\t' num2str((6+2*j+2*k)*N+l) ',\t' num2str((4+2*j)*N+1) ',\t' '\n']);
fprintf(fw,[num2str((8+2*j+2*k)*N+4*l+2) ',\t' num2str((6+2*j+2*k)*N+l+l) ',\t' num2str((4+2*j+k)*N+1) ',\t' '\n']);
fprintf(fw,[num2str((8+2*j+2*k)*N+4*l+3) ',\t' num2str((6+2*j+2*k)*N+2*l+l) ',\t' num2str((4+2*j)*N+N*k-k+1) ',\t' '\n']);
fprintf(fw,[num2str((8+2*j+2*k)*N+4*l+4) ',\t' num2str((6+2*j+2*k)*N+3*l+l) ',\t' num2str((4+2*j+k)*N+N*k-k+1) ',\t' '\n']);

%%
fprintf(fw,['*Elset, elset=Hengestenger' '\n']);
for n=1:N-2
   fprintf(fw,[num2str((6+2*j+2*k)*N+n) ',\t' '\n']); 
   
end 
for n=1:N-2
    fprintf(fw,[num2str((7+2*j+2*k)*N+n) ',\t' '\n']);
end

fprintf(fw,['*Elset, elset=Kabel' '\n']);
for n=1:k*N-k
   fprintf(fw,[num2str((6+2*j+k)*N+n) ',\t' '\n']); 
end 
for n=1:k*N-k
    fprintf(fw,[num2str((6+2*j)*N+n) ',\t' '\n']);
end

fprintf(fw,['*Elset, elset=Masselose' '\n']);
for n=1:N-1
   fprintf(fw,[num2str(2*N+n) ',\t' '\n']); 
end 
for n=1:N-1
    fprintf(fw,[num2str(3*N+n) ',\t' '\n']);
end
for n=1:N-1
    fprintf(fw,[num2str(4*N+n) ',\t' '\n']);
end
for n=1:N-1
    fprintf(fw,[num2str(5*N+n) ',\t' '\n']);
end
 
fprintf(fw,['*Elset, elset=Midtbjelke' '\n']);
for n=1:N-1
   fprintf(fw,[num2str(n) ',\t' '\n']); 
end 
for n=1:N-1
   fprintf(fw,[num2str(N+n) ',\t' '\n']); 
end 

fprintf(fw,['*Elset, elset=Brobane1' '\n']);
for n=1:j*N-1
   fprintf(fw,[num2str(6*N+n) ',\t' '\n']); 
end 

fprintf(fw,['*Elset, elset=Brobane2' '\n']);
for n=1:j*N-1
   fprintf(fw,[num2str((6+j)*N+n) ',\t' '\n']); 
end 

fprintf(fw,['*Nset, nset=midtnoder' '\n']);
for n=1:N-2
   fprintf(fw,[num2str((5+2*j+2*k)*N+n+1) ',\t' '\n']); 
end 
 
fprintf(fw,['*Nset, nset=brubane1' '\n']);
for n=1:N-2
   fprintf(fw,[num2str(N+j*n+1) ',\t' '\n']); 
end 

fprintf(fw,['*Nset, nset=brubane2' '\n']);
for n=1:N-2
   fprintf(fw,[num2str((3+j)*N+j*n+1) ',\t' '\n']); 
end 

fprintf(fw,['*Nset, nset=ovrehengestangfeste' '\n']);
for n=1:N-2
   fprintf(fw,[num2str((4+2*j)*N+k*n+1) ',\t' '\n' ]); 
end 
for n=1:N-2
   fprintf(fw,[num2str((4+2*j+k)*N+k*n+1) ',\t' '\n']); 
end 
fprintf(fw,['*End Part' '\n']);

%%

fprintf(fw,['*Part, name=Trn' '\n']);
fprintf(fw,['*NODE' '\n']);

N=(Ht-Hv)/dx+1;

for n=1:N
     fprintf(fw,[num2str(n) ',\t' num2str(x0) ',\t' num2str(Hv+dx*(n-1)) ',\t' num2str(z3+(Ht-Hv-dx*(n-1))*0.04513) ',\t' '\n']);
end
for n=1:N
     fprintf(fw,[num2str(n+N) ',\t' num2str(x0) ',\t' num2str(Hv+dx*(n-1)) ',\t' num2str(-(z3+(Ht-Hv-dx*(n-1))*0.04513)) ',\t' '\n']);
end
fprintf(fw,[num2str(2*N+1) ',\t' num2str(x0) ',\t' num2str(y0) ',\t' num2str(z2) ',\t' '\n']);
fprintf(fw,[num2str(2*N+2) ',\t' num2str(x0) ',\t' num2str(y0) ',\t' num2str(z0) ',\t' '\n']);
fprintf(fw,[num2str(2*N+3) ',\t' num2str(x0) ',\t' num2str(y0) ',\t' num2str(-z2) ',\t' '\n']);

for n=1:N
     fprintf(fw,[num2str(n+3*N) ',\t' num2str(x2) ',\t' num2str(Hv+dx*(n-1)) ',\t' num2str(z3+(Ht-Hv-dx*(n-1))*0.04513) ',\t' '\n']);
end
for n=1:N
     fprintf(fw,[num2str(n+4*N) ',\t' num2str(x2) ',\t' num2str(Hv+dx*(n-1)) ',\t' num2str(-(z3+(Ht-Hv-dx*(n-1))*0.04513)) ',\t' '\n']);
end
fprintf(fw,[num2str(5*N+1) ',\t' num2str(x2) ',\t' num2str(y0) ',\t' num2str(z2) ',\t' '\n']);
fprintf(fw,[num2str(5*N+2) ',\t' num2str(x2) ',\t' num2str(y0) ',\t' num2str(z0) ',\t' '\n']);
fprintf(fw,[num2str(5*N+3) ',\t' num2str(x2) ',\t' num2str(y0) ',\t' num2str(-z2) ',\t' '\n']);

fprintf(fw,['*Element, type=B33' '\n']);
for n=1:N-1 
    fprintf(fw,[num2str(n) ',\t' num2str(n) ',\t' num2str(n+1) ',\t' '\n']);
end
for n=1:N-1 
    fprintf(fw,[num2str(n+N) ',\t' num2str(n+N) ',\t' num2str(n+N+1) ',\t' '\n']);
end
for n=1:N-1 
    fprintf(fw,[num2str(n+3*N) ',\t' num2str(n+3*N) ',\t' num2str(n+3*N+1) ',\t' '\n']);
end
for n=1:N-1 
    fprintf(fw,[num2str(n+4*N) ',\t' num2str(n+4*N) ',\t' num2str(n+4*N+1) ',\t' '\n']);
end

fprintf(fw,[num2str(1+5*N) ',\t' num2str(4) ',\t' num2str(2*N+1) ',\t' '\n']);
fprintf(fw,[num2str(2+5*N) ',\t' num2str(2*N+1) ',\t' num2str(2*N+2) ',\t' '\n']);
fprintf(fw,[num2str(3+5*N) ',\t' num2str(2*N+2) ',\t' num2str(2*N+3) ',\t' '\n']);
fprintf(fw,[num2str(4+5*N) ',\t' num2str(4+N) ',\t' num2str(2*N+3) ',\t' '\n']);

fprintf(fw,[num2str(5+5*N) ',\t' num2str(12) ',\t' num2str(12+N) ',\t' '\n']);
fprintf(fw,[num2str(6+5*N) ',\t' num2str(N) ',\t' num2str(N+N) ',\t' '\n']);

fprintf(fw,[num2str(7+5*N) ',\t' num2str(4+3*N) ',\t' num2str(5*N+1) ',\t' '\n']);
fprintf(fw,[num2str(8+5*N) ',\t' num2str(5*N+1) ',\t' num2str(5*N+2) ',\t' '\n']);
fprintf(fw,[num2str(9+5*N) ',\t' num2str(5*N+2) ',\t' num2str(5*N+3) ',\t' '\n']);
fprintf(fw,[num2str(10+5*N) ',\t' num2str(4+4*N) ',\t' num2str(5*N+3) ',\t' '\n']);

fprintf(fw,[num2str(11+5*N) ',\t' num2str(12+3*N) ',\t' num2str(12+4*N) ',\t' '\n']);
fprintf(fw,[num2str(12+5*N) ',\t' num2str(N+3*N) ',\t' num2str(N+N*4) ',\t' '\n']);

fprintf(fw,['*Elset, elset=Tverr1' '\n']);
for n=1:4
   fprintf(fw,[num2str(5*N+n) ',\t' '\n']); 
end
for n=7:10
   fprintf(fw,[num2str(5*N+n) ',\t' '\n']); 
end

fprintf(fw,['*Elset, elset=Tverr2' '\n']);

   fprintf(fw,[num2str(5*N+5) ',\t' '\n']); 
   fprintf(fw,[num2str(5*N+11) ',\t' '\n']); 
   
fprintf(fw,['*Elset, elset=Tverr3' '\n']);

   fprintf(fw,[num2str(5*N+6) ',\t' '\n']); 
   fprintf(fw,[num2str(5*N+12) ',\t' '\n']); 


fprintf(fw,['*Elset, elset=Trnbein1' '\n']);
for n=1:5
   fprintf(fw,[num2str(n) ',\t' '\n']); 
   fprintf(fw,[num2str(n+N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+3*N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+4*N) ',\t' '\n']);
end 
fprintf(fw,['*Elset, elset=Trnbein2' '\n']);
for n=6:11
   fprintf(fw,[num2str(n) ',\t' '\n']); 
   fprintf(fw,[num2str(n+N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+3*N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+4*N) ',\t' '\n']);
end 
fprintf(fw,['*Elset, elset=Trnbein3' '\n']);
for n=12:N-1
   fprintf(fw,[num2str(n) ',\t' '\n']); 
   fprintf(fw,[num2str(n+N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+3*N) ',\t' '\n']); 
   fprintf(fw,[num2str(n+4*N) ',\t' '\n']);
end 


fprintf(fw,['*End Part' '\n']);

%%

fprintf(fw,['*Assembly, name=Assembly' '\n']);
fprintf(fw,['*Instance, name=Part-1-1, part=Part-1' '\n']);
fprintf(fw,['*End Instance' '\n']);
fprintf(fw,['*Instance, name=Trn-1, part=Trn' '\n']);
fprintf(fw,['*End Instance' '\n']);

N=L/dx + 1;

fprintf(fw,['*Nset, nset=midtnoder, instance=Part-1-1' '\n']);
for n=1:N-2
   fprintf(fw,[num2str((5+2*j+2*k)*N+n+1) ',\t' '\n']); 
end 

N=(Ht-Hv)/dx+1;

fprintf(fw,['*Nset, nset=midtnoder, instance=Trn-1' '\n']);
fprintf(fw,[num2str(2*N+2) ',\t' '\n']); 
fprintf(fw,[num2str(5*N+2) ',\t' '\n']); 

fprintf(fw,['*End Assembly' '\n']);

fclose(fw);









