%3 komponent responsberegninger for en mode Henrik Skyvulstad 16.04.11

clc
clear all
close all
 
 tic
for vv=1:1:5                        %genererer vind (fra 5 m/s - 35 m/s)
%Konstanter
V=vv*6;                             %middelvind (meter/sek)
domegaw=0.005;                      %itersjonsomega
omegaw=0.0001:domegaw:2;            %utvalget av frekvenser (rad)
rho=1.25;                           %luftens tetthet (kg/m3)
B=18.3;                             %Bredde p brukassa(m)
d=3.33;                             %dybde p brukassa(m)
Nodes=186;                          %antal noder fra abaqus
L=3700;                             %lengde hovedspenn(m)
Lexp=3700;                          %"forblst" lengde
dx=L/(Nodes-1);                     %itterasjonslengde
dxexp=L/(Nodes-1);                  %eksponert itterasjonslende 
xexp=0:dxexp:Lexp;                  %Lengdevektor eksponert
x=0:dx:L;                           %Lengdevektor hele brua


Cux=1.4;                            %nomalized co-spectrum coeffisienter
Cwx=1.4;


%% 
VALGT=(1:30);                       %velg hvilke moder som skal vre med

%% Importer abaqus data, ikke rr
[Eigenvectors,Eigenvalues]=read_ABAQUS_dat('HM.dat',Nodes);   %sett inn navn p dat fil fra Abaqus
omegaomega=(Eigenvalues(VALGT,3));

%% Definerer moden, ikke rr
Koordinater=Eigenvectors(:,2:4);
[~, b]=sort(Koordinater(:,1));
Koordinater=Koordinater(b,:);

phiphi=zeros(3,size(Eigenvectors,1),length(VALGT));
teller=1;
for n=1:length(omegaomega)
    phiphi(2,:,teller)=Eigenvectors(b,6,VALGT(n))';
    phiphi(1,:,teller)=Eigenvectors(b,7,VALGT(n))';
    phiphi(3,:,teller)=Eigenvectors(b,8,VALGT(n))';
    Skalering=max([phiphi(1,:,teller) phiphi(2,:,teller) B/2*phiphi(3,:,teller) ]);
%     figure
%     subplot(3,1,1)
%     plot(Koordinater(:,1),phiphi(1,:,teller))
%     ylim([-Skalering Skalering])
%     title(['Mode ' num2str(VALGT(n)) ' \omega=' num2str(omegaomega(teller,1)) ' (rad/s)'])
%     grid on
%     subplot(3,1,2)
%     plot(Koordinater(:,1),phiphi(2,:,teller))
%     ylim([-Skalering Skalering])
%     grid on
%     subplot(3,1,3)
%     plot(Koordinater(:,1),phiphi(3,:,teller))
%     ylim([-2/B*Skalering 2/B*Skalering])
%     grid on
    teller=teller+1;
end


%% Definer stille luft egenskapene
omegaomega=diag(Eigenvalues(VALGT,3));              %diagonal matrise med egenfrekvenser
M=diag(Eigenvalues(VALGT,5));                       %diagonal matrise med modale masser
zetazeta=0.005.*diag(ones(length(VALGT),1));        %dempingsmatrise, modal
K=omegaomega.^2*M;                                  %stivhetsmatrise, modal
C=2.*zetazeta.*M.*omegaomega;                         
omega=diag(omegaomega);                             %sylevektor med egenverdier        


dx1=zeros(1,length(x));
dxexp1=zeros(1,length(x));
for a=1:1:length(x)
dx1(1,a)=dx;                                        %vektor med dx-er (til integrering)
dxexp1(1,a)=dxexp;                                  %vektor med dxexp-er  
end

domegaw1=zeros(1,length(omegaw));
for a1=1:1:length(omegaw)
    domegaw1(1,a1)=domegaw;                         %vektor med domegaw-er (til integrering)
end

    phiphi1=zeros(1,1,length(omega));
    phiphi2=zeros(1,1,length(omega));
    phiphi3=zeros(1,1,length(omega));
    phiphi12=zeros(1,1,length(omega));
    phiphi13=zeros(1,1,length(omega));
    phiphi23=zeros(1,1,length(omega));
    phiphi1exp=zeros(1,1,length(omega));
    phiphi2exp=zeros(1,1,length(omega));
    phiphi3exp=zeros(1,1,length(omega));
    phiphi12exp=zeros(1,1,length(omega));
    phiphi13exp=zeros(1,1,length(omega));
    phiphi23exp=zeros(1,1,length(omega));
    

%integrerte formfuntioner 
for u=1:1:length(omega)

    phiphi1(1,1,u)=phiphi(1,:,u).^2*dx1';
    phiphi2(1,1,u)=phiphi(2,:,u).^2*dx1';
    phiphi3(1,1,u)=phiphi(3,:,u).^2*dx1';
    phiphi12(1,1,u)=phiphi(1,:,u).*phiphi(2,:,u)*dx1';
    phiphi13(1,1,u)=phiphi(1,:,u).*phiphi(3,:,u)*dx1';
    phiphi23(1,1,u)=phiphi(2,:,u).*phiphi(3,:,u)*dx1';
    phiphi1exp(1,1,u)=phiphi(1,:,u).^2*dxexp1';
    phiphi2exp(1,1,u)=phiphi(2,:,u).^2*dxexp1';
    phiphi3exp(1,1,u)=phiphi(3,:,u).^2*dxexp1';
    phiphi12exp(1,1,u)=phiphi(1,:,u).*phiphi(2,:,u)*dxexp1';
    phiphi13exp(1,1,u)=phiphi(1,:,u).*phiphi(3,:,u)*dxexp1';
    phiphi23exp(1,1,u)=phiphi(2,:,u).*phiphi(3,:,u)*dxexp1';
end           
    
%Drag, lift of moment koeffisienter (PS. verdier fra Hardangerbrua)

%middel
CDs=0.749;                            %disse med strek over, middel verdien! 
CLs=-0.254;
CMs=0.004;

%helning
CDm=0;                                %m angir merket, alts helningen
CLm=2.502;
CMm=0.859;

%vind normalt p bruaksen

zf=50;                   %Hyde over bakken (m)
z0=0.01;                 %Ruhetslengde (m)
kt=0.17;                 %terrengruhetsfaktor 1
ctt=1.2;                 %Turbulence faktor
vb=26;                   %basisvindhastigheten (m/s)
cr=kt*log(zf/z0);        %terrengruhetsfaktor 2
vs=V;                    %middelvind i hyde z (m/s)
Iu=ctt/(log(zf/z0));     %Turbulenceintensiteten i u-retn
Iv=0.75*Iu;              %Turbulenceintensiteten i v-retn
Iw=0.5*Iu;               %Turbulenceintensiteten i w-retn
sigmau=Iu*vs;            %variansen i u-retn
sigmav=Iv*vs;            %variansen i v-retn
sigmaw=Iw*vs;            %variansen i w-retn
xfLu=360;                %integrale lengdeskala (m)
au=6.8;                  %Langsgende turbulensekoeffesient
av=1.9;                  %Langsgende turbulensekoeffesient
aw=0.55;                 %Langsgende turbulensekoeffesient
omegahatt=(omegaw/2*pi)*(xfLu/vs);
Su=(1/(2*pi))*(au*omegahatt*sigmau^2)./((omegaw/2*pi).*(1+1.5*au*omegahatt).^(5/3));    %spektraltettheten til u
Sv=(1/(2*pi))*(av*omegahatt*sigmav^2)./((omegaw/2*pi).*(1+1.5*av*omegahatt).^(5/3));    %spektraltettheten til v
Sw=(1/(2*pi))*(aw*omegahatt*sigmaw^2)./((omegaw/2*pi).*(1+1.5*aw*omegahatt).^(5/3));    %spektraltettheten til w  
   
vred=zeros(length(omega),1);

for y=1:1:length(omegaomega)
    vred(y,1)=V/(omega(y,1)*B);
end


load AE.txt;  %henter verdier fra AE tekst( AERODYNAMISKE DERIVERTE, ps. 2 metoder  hente de ut p)

for yy=1:1:length(omegaomega) %genererer aerodynamiske deriverte
AD(:,1,yy)=AE(:,1).*vred(yy,1)^3+AE(:,2).*vred(yy,1)^2+AE(:,3).*vred(yy,1)+AE(:,4);
end


P1(:,1)=AD(1,1,:);
P2(:,1)=AD(2,1,:);
P3(:,1)=AD(3,1,:);
P4(:,1)=AD(4,1,:);
P5(:,1)=AD(5,1,:);
P6(:,1)=AD(6,1,:);

H1(:,1)=AD(1,1,:);
H2(:,1)=AD(2,1,:);
H3(:,1)=AD(3,1,:);
H4(:,1)=AD(4,1,:);
H5(:,1)=AD(5,1,:);
H6(:,1)=AD(6,1,:);

A1(:,1)=AD(1,1,:);
A2(:,1)=AD(2,1,:);
A3(:,1)=AD(3,1,:);
A4(:,1)=AD(4,1,:);
A5(:,1)=AD(5,1,:);
A6(:,1)=AD(6,1,:);


%Buffeting theory

Caehatt=zeros(3,3,length(omega));           %aerodyn demping
Kaehatt=zeros(3,3,length(omega));           %aerodyn stivhet
    
for r=1:1:length(omegaomega)     %kjrer gjennom pga. forskjellige egenfrekvenser i modene, se aeroderiverte

    
    
Bqhatt=[2*(d/B)*CDs, ((d/B)*CDm-CLs);2*CLs,(CLm+(d/B)*CDs);...
    2*B*CMs,B*CMm];
Bq=Bqhatt*(rho*V*(B/2));

Caehatt(:,:,r)=([P1(r,1),0,0;0,H1(r,1),0;0,0, B^2*A2(r,1)]);
%Caehatt(:,:,r)=([P1(r,1),P5(r,1),B*P2(r,1);H5(r,1),H1(r,1),B*H2(r,1);B*A5(r,1),B*A1(r,1), B^2*A2(r,1)]);
Kaehatt(:,:,r)=([P4(r,1),0,0;0,H4(r,1),0;0,0,B^2*A3(r,1)]);
%Kaehatt(:,:,r)=([P4(r,1),P6(r,1),B*P3(r,1);H6(r,1),H4(r,1),B*H3(r,1);B*A6(r,1),B*A4(r,1),B^2*A3(r,1)]);

Ivv=diag([Iu Iw]);
end


%integraler


phi11=zeros(length(omegaomega),1);                  %forfuntionsareal
phiexp11=zeros(length(omegaomega),1);               %eksponert forfuntionsareal
kaehattint=zeros(length(omegaomega),1);             %aerodyn stihetsforhold, integrert
Caehattint=zeros(length(omegaomega),1);             %aerodyn dempingsforhold, integrert
mm=zeros(length(omegaomega),1);                     %Normalisert masseledd
kae=zeros(length(omegaomega),1);                    %Aerodyn stivhetsforhold
ksiae=zeros(length(omegaomega),1);                  %Aerodyn dempingsforhold
H=zeros(length(omegaomega),length(omegaw));         %Modal-frequency-response function
I=zeros(length(omegaomega),length(omegaw));         %part of joint acceptence funtion
J=I;
Jhatt=zeros(length(omega),length(omegaw));
sigma=zeros(3,length(omega));                       %variance matrix

%prver for en mode, s eventuelt legge sammen modene



for e=1:1:length(omegaomega)



    for q=1:1:length(x)
phi11(e)=phi11(e)+dx*phiphi(:,q,e)'*phiphi(:,q,e);
phiexp11(e)=phiexp11(e)+dxexp*phiphi(:,q,e)'*phiphi(:,q,e);
kaehattint(e)=kaehattint(e)+dxexp*phiphi(:,q,e)'*Kaehatt(:,:,e)*phiphi(:,q,e);
Caehattint(e)=Caehattint(e)+dxexp*phiphi(:,q,e)'*Caehatt(:,:,e)*phiphi(:,q,e);


    end


mm(e,1)=M(e,e)/phi11(e);   %normalisert modal masse

kae(e,1)=((rho*B^2)/(2*mm(e,1)))*((kaehattint(e))/(phi11(e)));
ksiae(e,1)=((rho*B^2)/(4*mm(e,1)))*((Caehattint(e))/(phi11(e)));

%modal frequency response spectrum
H(e,:,vv)=1./(1-kae(e,1)-(omegaw/omega(e,1)).^2+2*1i*(zetazeta(e,e)-ksiae(e,1))*(omegaw/omega(e,1))); %frequency response fungtion


%The joint acceptence function


for n=1:1:length(omegaw)
    for j=1:1:length(x)
        for k=1:1:length(x)
        deltax=abs(x(k)-x(j));
        I(e,n)=I(e,n)+dx*dx*phiphi(:,j,e)'*Bqhatt*Ivv.^2*[Su(n)*(1/(sigmau^2))*exp(-Cux*omegaw(n)*deltax/V),0;0,Sw(n)*(1/(sigmaw^2))*exp(-Cwx*omegaw(n)*deltax/V)]*Bqhatt'*phiphi(:,k,e);
        end
    end
end
J(e,:)=I(e,:);
Jhatt(e,:)=(sqrt(I(e,:)))/((phi11(e))); %normalisert joint acceptense %

%generering av midtpunkt

f=0.5;      %punkt p brua (0.5 = halve lengden)
f1=Nodes*f;
xr=f1; 

%variansen i punkt xr

sigma(1,e,vv)=phiphi(1,xr,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %var i horr
sigma(2,e,vv)=phiphi(2,xr,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %var i vert
sigma(3,e,vv)=phiphi(3,xr,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %var i torsj



%variansen over spennet

sigma11(:,e,vv)=phiphi(1,:,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %genererer spenn-varansen
sigma22(:,e,vv)=phiphi(2,:,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %genererer spenn-varansen
sigma33(:,e,vv)=phiphi(3,:,e)*rho*B^3*(1/(2*mm(e,1)))*(V/(B*omega(e,1)))^2*sqrt(abs(H(e,:)).^2*Jhatt(e,:)'.^2*domegaw); %genererer spenn-varansen

%Spektraltettheten i punkt xr

Sry(e,:,vv)=phiphi(1,xr,e)^2*(abs(H(e,:))).^2*(1/K(e,e))^2*(rho*V^2*B/2)^2.*J(e,:).^2;
Srz(e,:,vv)=phiphi(2,xr,e)^2*(abs(H(e,:))).^2*(1/K(e,e))^2*(rho*V^2*B/2)^2.*J(e,:).^2;
Srt(e,:,vv)=phiphi(3,xr,e)^2*(abs(H(e,:))).^2*(1/K(e,e))^2*(rho*V^2*B/2)^2.*J(e,:).^2;



end

%summerer variancen for hver hastighet

Sigma(:,1,vv)=sum(abs(sigma(:,:,vv)),2);                 %Gir summert varians i hvert retning


end 

%genererer sum av spectraltetthetene over modene

Sry1=sum(abs(Sry(:,:,vv)));                     %pass p vv i denne, plotter kun den siste i rekka!!!
Srz1=sum(abs(Srz(:,:,vv)));                     %summer opp Sr-bidraget fra hver rekke
Srt1=sum(abs(Srt(:,:,vv)));                     


Sigma1(:,:)=Sigma(:,1,:);                       %genererer en 2d matrise for plotting
vvv=5:5:30;                                     %genererer vindhastighetsmatrisen 
sigma111=sum(abs(sigma11),2);                   %summerer matrisa i moderetning
sigma222=sum(abs(sigma22),2);                   %summerer matrisa i moderetning
sigma333=sum(abs(sigma33),2);                   %summerer matrisa i moderetning

%modevirkning v=30m/s, midspenn

figure
plot(VALGT,abs(sigma(1,:,vv)),'o')
grid on
xlabel( 'Mode nr' )
ylabel( 'Variance (m)' )
title( 'Plot horisontal variance against modes at midspan and V=30m/s' )

figure
plot(VALGT,abs(sigma(2,:,vv)),'o')
grid on
xlabel( 'Mode nr' )
ylabel( 'Variance (m)' )
title( 'Plot vertical variance against modes at midspan and V=30m/s' )

figure
plot(VALGT,abs(sigma(3,:,vv)),'o')
grid on
xlabel( 'Mode nr' )
ylabel( 'Variance (rad)' )
title( 'Plot torsjon variance against modes at midspan and V=30m/s' )

%varians over spenn v=30m/s

figure
plot(x,sigma111(:,vv))
grid on
xlabel( 'Point on bridge, (m)' )
ylabel( 'Variance (m)' )
title( 'Plot horisontal variance over the spann of the bridge at V=30 m/s' )

figure
plot(x,sigma222(:,vv))
grid on
xlabel( 'Point on bridge, (m)' )
ylabel( 'Variance (m)' )
title( 'Plot vetical variance over the spann of the bridge at V=30 m/s' )

figure
plot(x,sigma333(:,vv))
grid on
xlabel( 'Point on bridge, (m)' )
ylabel( 'Variance (rad)' )
title( 'Plot torsional variance over the spann of the bridge at V=30 m/s' )

%genererer varians mot meanwind at midspan
figure
plot(vvv,Sigma1(1,:))
grid on
xlabel( 'mean wind, V (m/s)' )
ylabel( 'Variance (m)' )
title( 'Plot horisontal variance vs mean wind velocity at midspan' )


figure
plot(vvv,Sigma1(2,:))
grid on
xlabel( 'mean wind, V (m/s)' )
ylabel( 'Variance (m)' )
title( 'Plot vertical variance vs mean wind velocity at midspan' )


figure
plot(vvv,Sigma1(3,:))
grid on
xlabel( 'mean wind, V (m/s)' )
ylabel( 'Variance (rad)' )
title( 'Plot rotational variance vs mean wind velocity at midspan' )

%finner variansen i siste punkt

Sigma(1,:,vv)

Sigma(2,:,vv)

Sigma(3,:,vv)

%genererer spectraltetthet i midtpunkt mot V=30 m/s

figure
loglog(omegaw,Sry1)
grid on
xlabel( 'omega (rad/s)' )
ylabel( 'Sry (sm^2)' )
title( 'Spectral density in horisontal direction with V=30m/s at midspan' )

figure
loglog(omegaw,Srz1)
grid on
xlabel( 'omega (rad/s)' )
ylabel( 'Srz (sm^2)' )
title( 'Spectral density in vertikal direction with V=30m/s at midspan' )

figure
loglog(omegaw,Srt1)
grid on
xlabel( 'omega (rad/s)' )
ylabel( 'Srt ' )
title( 'Spectral density in torsional direction with V=30m/s at midspan' )

%random plot som kanskje kan vre aktuelle
%plotter Sry for de 5 frste modene i horisontal
figure
loglog(omegaw,Sry(1:5,:,vv))
grid on
xlabel( 'omega (rad/s)' )
ylabel( 'Sry (sm^2)' )
title( 'Spectral density in horisontal direction with V=30m/s at midspan, 5 first modes' )
legend( 'mode 1', 'mode 2', 'mode 3', 'mode 4', 'mode 5')


figure
plot(omegaw,abs(H(1:5,:,vv)))
grid on
xlabel( 'omega (rad/s)' )
ylabel( '|H| ' )
title( 'Modal frequenzy responce funtion, 5 first modes' )
legend( 'mode 1', 'mode 2', 'mode 3', 'mode 4', 'mode 5')

%plotting av accelerasjons specterene

figure
loglog(omegaw/(2*pi), Sry1*2*pi.*(omegaw/(2*pi)).^4)
grid on
xlabel( 'frequency (Hz)' )
ylabel( 'Acceleration (m/s2)2/s' )
title( 'Plot of spectral acceleration at mid-span for V=30m/s' )

figure
loglog(omegaw/(2*pi), Srz1*2*pi.*(omegaw/(2*pi)).^4)
grid on
xlabel( 'frequency (Hz)' )
ylabel( 'Acceleration (m/s2)2/s' )
title( 'Plot of spectral acceleration at mid-span for V=30m/s' )

save vindresponsresultater.mat  %lagrer resultatene
toc %viser hvor lang tid plottet har tatt