%SOGNEBRIDGE
 
%Preliminary design of cables and hangers
clear all
clc
%% 
%Inputparametere
lambda=20;                  %Distance between hangers, m
gb=5983*9.81*1.2;           %Self weight girder, N/m
p=2897*9.81*1.6;            %Additional weight on girder, N/m
d=3.3;                      %Height of girder, m
P=210000;                   %Pointmass girder, N
fcbd=1570*10^6;             %Design stress, N/m^2
lm=3700;                    %Mains-pan, m
km=lm/10;                   %Sag
Am=0.1;                     %Area main cable, starting value, m^2
gammacb=7850;               %Density of steel
 
%%
%Hangers
Th=(gb+p)*lambda + 3*P*lambda/(30*d);   %Stress in hanger, N
Ah=Th/fcbd*0.5;                         %One hanger on each side, m^2
 
%%
%Cable 
n=5;
for i=1:n
    gcb=Am*gammacb;
    Hm=((gb+p)*lm^2+2*P*lm)/(8*km)+gcb*lm^2/(8*km);
    Tm=Hm*sqrt(lm^2+16*km^2)/lm;
    %Am=(((g+p)*lm+2*P)*sqrt(lm^2-16*km^2))/...
    %(8*fcbd*km-gammacb*lm*sqrt(lm^2+16*km^2));
    Am=Tm/fcbd*0.5;
end
 
fim=acos(Hm/Tm);
A=[Ah Am Aa];
 
%% Vertical forces in pylons
 
Vm=sqrt(Tm^2-Hm^2);     %Assume same angle on cable on both sides of pylon.
Vm = Vm*10^(-3);        

